﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Syncfusion.EJ2;
using Syncfusion.EJ2.Navigations;

namespace RemoteData.Controllers
{

    public class TreeviewController: Controller
    {
        public class ParentNodeViewModel
        {
            public string nodeId { get; set; }
            public string nodeText { get; set; }
            public string pid { get; set; }
            public Boolean hasChild { get; set; }
            public Boolean expanded { get; set; }
        }

        List<ParentNodeViewModel> TreeData;
        public List<ParentNodeViewModel> TemplateData
        {
            get
            {
                if (TreeData == null)
                    InitializeTempateData();
                return TreeData;
            }
        }

        private void InitializeTempateData()
        {
            TreeData = new List<ParentNodeViewModel>();
            TreeData.Add(new ParentNodeViewModel {nodeId = "01", nodeText= "Local Disk (C:)", expanded= true, hasChild= true });
            TreeData.Add(new ParentNodeViewModel { nodeId = "01-01", nodeText = "Program Files", hasChild = true , pid = "01" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "01-01-01", nodeText = "Windows NT", pid="01-01" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "01-01-02", nodeText = "Windows Mail", pid = "01-01" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "01-01-03", nodeText = "Windows Photo Viewer", pid = "01-01" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "01-02", nodeText = "Users", pid = "01" , hasChild=true, expanded=true});
            TreeData.Add(new ParentNodeViewModel { nodeId = "01-02-01", nodeText = "Smith", pid = "01-02" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "01-02-02", nodeText = "Public", pid = "01-02" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "01-02-03", nodeText = "Admin", pid = "01-02" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "01-03", nodeText = "Windows", pid = "01", hasChild = true });
            TreeData.Add(new ParentNodeViewModel { nodeId = "01-03-01", nodeText = "Boot", pid = "01-03" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "01-03-02", nodeText = "FileManager", pid = "01-03" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "01-03-03", nodeText = "System32", pid = "01-03" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "02", nodeText = "Local Disk (D:)",  hasChild = true });
            TreeData.Add(new ParentNodeViewModel { nodeId = "02-01", nodeText = "Personals", hasChild = true, pid = "02" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "02-01-01", nodeText = "My photo.png", pid = "02-01" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "02-01-02", nodeText = "Rental document.docx", pid = "02-01" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "02-01-03", nodeText = "Pay slip.pdf", pid = "02-01" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "02-02", nodeText = "Projects", hasChild = true, pid = "02" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "02-02-01", nodeText = "ASP Application", pid = "02-02" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "02-02-02", nodeText = "TypeScript Application", pid = "02-02" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "02-02-03", nodeText = "React Application", pid = "02-02" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "02-03", nodeText = "Office", hasChild = true, pid = "02" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "02-03-01", nodeText = "Work details.docx", pid = "02-03" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "02-03-02", nodeText = "Weekly report.docx", pid = "02-03" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "02-03-03", nodeText = "Wish list.csv", pid = "02-03" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "03", nodeText = "Local Disk (E:)", hasChild = true });
            TreeData.Add(new ParentNodeViewModel { nodeId = "03-01", nodeText = "Pictures", pid = "03", hasChild = true });
            TreeData.Add(new ParentNodeViewModel { nodeId = "03-01-01", nodeText = "Wind.jpg", pid = "03-01" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "03-01-02", nodeText = "Stone.jpg", pid = "03-01" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "03-01-03", nodeText = "Home.jpg", pid = "03-01" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "03-02", nodeText = "Documents", pid = "03", hasChild = true });
            TreeData.Add(new ParentNodeViewModel { nodeId = "03-02-01", nodeText = "Environment Pollution.docx", pid = "03-02" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "03-02-02", nodeText = "Global Warming.ppt", pid = "03-02" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "03-02-03", nodeText = "Social Network.pdf", pid = "03-02" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "03-03", nodeText = "Study Materials", pid = "03", hasChild = true });
            TreeData.Add(new ParentNodeViewModel { nodeId = "03-03-01", nodeText = "UI-Guide.pdf", pid = "03-03" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "03-03-02", nodeText = "Tutorials.zip", pid = "03-03" });
            TreeData.Add(new ParentNodeViewModel { nodeId = "03-03-03", nodeText = "TypeScript.7z", pid = "03-03" });
        }

        [HttpGet]
        [HttpPost]
        [ActionName("GetAllData")]
        public IEnumerable<ParentNodeViewModel> GetAllData()
        {
            return TemplateData;
        }
    }
}
